window.Gleam.initSearch([{"doc":"quaternion","title":"quaternion","content":"# README\n\nA simple quaternion implementation made with and for *Gleam*. Heavily inspired by the *Rust* [quaternion](https://github.com/PistonDevelopers/quaternion) crate.\n\n# License\n\nLicensed under either of:\n\nApache License, Version 2.0, (LICENSE-APACHE or http://www.apache.org/licenses/LICENSE-2.0)\nMIT license (LICENSE-MIT or http://opensource.org/licenses/MIT)\nat your option.\n\n# Contribution\n\nUnless you explicitly state otherwise, any contribution intentionally submitted for inclusion in the work by you, as defined in the Apache-2.0 license, shall be dual licensed as above, without any additional terms or conditions.","url":"index.html"},{"doc":"vec3","title":"Vector3","content":"pub type Vector3 =\n  #(Float, Float, Float)\n\n\nSynonyms:\nvec3.Vector3\nvec3 Vector3","url":"vec3.html#Vector3"},{"doc":"vec3","title":"zero","content":"pub const zero: #(Float, Float, Float)\n\nSynonyms:\nvec3.zero\nvec3 zero","url":"vec3.html#zero"},{"doc":"vec3","title":"add","content":"pub fn add(\n  v: #(Float, Float, Float),\n  w: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.add\nvec3 add","url":"vec3.html#add"},{"doc":"vec3","title":"cross","content":"pub fn cross(\n  v: #(Float, Float, Float),\n  w: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.cross\nvec3 cross","url":"vec3.html#cross"},{"doc":"vec3","title":"dot","content":"pub fn dot(\n  v: #(Float, Float, Float),\n  w: #(Float, Float, Float),\n) -&gt; Float\n\nSynonyms:\nvec3.dot\nvec3 dot","url":"vec3.html#dot"},{"doc":"vec3","title":"length","content":"pub fn length(v: #(Float, Float, Float)) -&gt; Float\n\nSynonyms:\nvec3.length\nvec3 length","url":"vec3.html#length"},{"doc":"vec3","title":"negate","content":"pub fn negate(\n  v: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.negate\nvec3 negate","url":"vec3.html#negate"},{"doc":"vec3","title":"normalize","content":"pub fn normalize(\n  v: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.normalize\nvec3 normalize","url":"vec3.html#normalize"},{"doc":"vec3","title":"orthogonal","content":"pub fn orthogonal(\n  v: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.orthogonal\nvec3 orthogonal","url":"vec3.html#orthogonal"},{"doc":"vec3","title":"scale","content":"pub fn scale(\n  v: #(Float, Float, Float),\n  factor: Float,\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.scale\nvec3 scale","url":"vec3.html#scale"},{"doc":"vec3","title":"square_length","content":"pub fn square_length(v: #(Float, Float, Float)) -&gt; Float\n\nSynonyms:\nvec3.square_length\nvec3 square_length","url":"vec3.html#square_length"},{"doc":"vec3","title":"substract","content":"pub fn substract(\n  v: #(Float, Float, Float),\n  w: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.substract\nvec3 substract","url":"vec3.html#substract"},{"doc":"vec3","title":"times","content":"pub fn times(\n  v: #(Float, Float, Float),\n  w: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n\nSynonyms:\nvec3.times\nvec3 times","url":"vec3.html#times"},{"doc":"vec3","title":"vec3","content":"","url":"vec3.html"},{"doc":"quaternion","title":"Quaternion","content":"pub type Quaternion {\n  Quaternion(real: Float, imaginary: #(Float, Float, Float))\n}\n\nQuaternion(real: Float, imaginary: #(Float, Float, Float))\n\n\nSynonyms:\nquaternion.Quaternion\nquaternion Quaternion","url":"quaternion.html#Quaternion"},{"doc":"quaternion","title":"id","content":"pub const id: Quaternion\n\nSynonyms:\nquaternion.id\nquaternion id","url":"quaternion.html#id"},{"doc":"quaternion","title":"add","content":"pub fn add(a: Quaternion, b: Quaternion) -&gt; Quaternion\n Adds two quaternions\nSynonyms:\nquaternion.add\nquaternion add","url":"quaternion.html#add"},{"doc":"quaternion","title":"axis_angle","content":"pub fn axis_angle(\n  axis: #(Float, Float, Float),\n  angle: Float,\n) -&gt; Quaternion\n Constructs a quaternion representing the given angle (in radians) around the given axis\nSynonyms:\nquaternion.axis_angle\nquaternion axis_angle","url":"quaternion.html#axis_angle"},{"doc":"quaternion","title":"conjugate","content":"pub fn conjugate(q: Quaternion) -&gt; Quaternion\n Computes the conjugate of a quaternion.\nSynonyms:\nquaternion.conjugate\nquaternion conjugate","url":"quaternion.html#conjugate"},{"doc":"quaternion","title":"dot","content":"pub fn dot(q: Quaternion, r: Quaternion) -&gt; Float\n Computes the dot product of two quaternions.\nSynonyms:\nquaternion.dot\nquaternion dot","url":"quaternion.html#dot"},{"doc":"quaternion","title":"euler_angles","content":"pub fn euler_angles(x: Float, y: Float, z: Float) -&gt; Quaternion\n Constructs the quaternion representing the given euler angle rotations (in radian)\nSynonyms:\nquaternion.euler_angles\nquaternion euler_angles","url":"quaternion.html#euler_angles"},{"doc":"quaternion","title":"from_imaginary","content":"pub fn from_imaginary(i: #(Float, Float, Float)) -&gt; Quaternion\n Constructs a quaternion with only an imaginary part\nSynonyms:\nquaternion.from_imaginary\nquaternion from_imaginary","url":"quaternion.html#from_imaginary"},{"doc":"quaternion","title":"from_list","content":"pub fn from_list(q: List(Float)) -&gt; Result(Quaternion, String)\n\nSynonyms:\nquaternion.from_list\nquaternion from_list","url":"quaternion.html#from_list"},{"doc":"quaternion","title":"from_real","content":"pub fn from_real(r: Float) -&gt; Quaternion\n Constructs a quaternion with only a real part\nSynonyms:\nquaternion.from_real\nquaternion from_real","url":"quaternion.html#from_real"},{"doc":"quaternion","title":"length","content":"pub fn length(q: Quaternion) -&gt; Float\n Computes the length of a quaternion.\nSynonyms:\nquaternion.length\nquaternion length","url":"quaternion.html#length"},{"doc":"quaternion","title":"loosely_equals","content":"pub fn loosely_equals(\n  q: Quaternion,\n  r: Quaternion,\n  epsilon: Float,\n) -&gt; Bool\n Asserts if quaternions are loosely equals\nSynonyms:\nquaternion.loosely_equals\nquaternion loosely_equals","url":"quaternion.html#loosely_equals"},{"doc":"quaternion","title":"multiply","content":"pub fn multiply(q: Quaternion, r: Quaternion) -&gt; Quaternion\n Computes the product of two quaternions.\nSynonyms:\nquaternion.multiply\nquaternion multiply","url":"quaternion.html#multiply"},{"doc":"quaternion","title":"normalize","content":"pub fn normalize(q: Quaternion) -&gt; Quaternion\n\nSynonyms:\nquaternion.normalize\nquaternion normalize","url":"quaternion.html#normalize"},{"doc":"quaternion","title":"rotate_vector","content":"pub fn rotate_vector(\n  q: Quaternion,\n  v: #(Float, Float, Float),\n) -&gt; #(Float, Float, Float)\n Rotates a 3D vector using a quaternion.\nSynonyms:\nquaternion.rotate_vector\nquaternion rotate_vector","url":"quaternion.html#rotate_vector"},{"doc":"quaternion","title":"scale","content":"pub fn scale(q: Quaternion, factor: Float) -&gt; Quaternion\n Scales a quaternion (element-wise) by a scalar.\nSynonyms:\nquaternion.scale\nquaternion scale","url":"quaternion.html#scale"},{"doc":"quaternion","title":"square_length","content":"pub fn square_length(q: Quaternion) -&gt; Float\n Computes the squared length of a quaternion.\nSynonyms:\nquaternion.square_length\nquaternion square_length","url":"quaternion.html#square_length"},{"doc":"quaternion","title":"substract","content":"pub fn substract(a: Quaternion, b: Quaternion) -&gt; Quaternion\n Substracts two quaternions\nSynonyms:\nquaternion.substract\nquaternion substract","url":"quaternion.html#substract"},{"doc":"quaternion","title":"times","content":"pub fn times(a: Quaternion, b: Quaternion) -&gt; Quaternion\n Computes the product (element-wise) of two quaternions.\nSynonyms:\nquaternion.times\nquaternion times","url":"quaternion.html#times"},{"doc":"quaternion","title":"to_list","content":"pub fn to_list(q: Quaternion) -&gt; List(Float)\n\nSynonyms:\nquaternion.to_list\nquaternion to_list","url":"quaternion.html#to_list"},{"doc":"quaternion","title":"to_string","content":"pub fn to_string(q: Quaternion) -&gt; String\n\nSynonyms:\nquaternion.to_string\nquaternion to_string","url":"quaternion.html#to_string"},{"doc":"quaternion","title":"quaternion","content":"","url":"quaternion.html"}]);